/*
{
"CREDIT": "Martijn Steinrucken aka BigWings",
"DESCRIPTION": "Shroomiverse",
"CATEGORIES" : ["Generator"],
"ISFVSN" : "2",

"INPUTS" : [
{
"NAME" : "rate",
"TYPE" : "float",
"MIN" : -0.2,
"MAX" : 0.2,
"DEFAULT" : 0.03
},
{
"NAME" : "GridCount",
"LABEL" : "GridSize - speeds it up",
"TYPE" : "float",
"MIN" : 2,
"MAX" : 10,
"DEFAULT" : 4
},
{
"NAME" : "tint",
"LABEL" : "TINT",
"TYPE" : "color",
"DEFAULT" : [0.5,0.75,1.0,1]
},
{
"NAME" : 		"line",
"TYPE" : 		"float",
"DEFAULT" : 	0.75,
"MIN" : 		0.0,
"MAX" : 		0.9
},
{
"NAME" : 		"flash",
"TYPE" : 		"float",
"DEFAULT" : 	2.5,
"MIN" : 		0.5,
"MAX" : 		5.0
}

],
"PASSES" : [
{"HEIGHT" : 1,"WIDTH:" : 1,
"TARGET" : "TimeHold",
"persistent" : true,"FLOAT" : true,"PERSISTENT" : true,
"DESCRIPTION" : "time buffer - float target buffer..."},
{"DESCRIPTION" : "empty pass`"}
]
}
*/


// REad the time buffer
	vec4 getTime = IMG_PIXEL(TimeHold,vec2(0.5));
	float Atime = getTime.x;


float seed1 = 373.347;
float seed2 = 292.715;

// The Universe Within - by Martijn Steinrucken aka BigWings 2018
// Email:countfrolic@gmail.com Twitter:@The_ArtOfCode
// After listening to an interview with Michael Pollan on the Joe Rogan
// podcast I got interested in mystic experiences that people seem to
// have when using certain psycoactive substances.
// For best results, watch fullscreen, with music, in a dark room. (with shrooms)
// YouTube Tutorial for this effect: https://youtu.be/3CycKKJiwis
// ISF Mods by mojovideotech & a little by howie.tv

#define S(a, b, t) smoothstep(a, b, t)
#define NUM_LAYERS 4.
#define iChannel0

//#define SIMPLE
// thats a good question!

#define S(a, b, t) smoothstep(a, b, t)

float N1(float n) {
	return fract(sin(n) * 43758.5453123);
}

float N11(float p) {
	float fl = floor(p);
	float fc = fract(p);
	return mix(N1(fl), N1(fl + 1.0), fc);
}

float N21(vec2 p) { return fract(sin(p.x * floor(seed1) + p.y * floor(seed2)) * floor(seed2+seed1)); }

vec2 N22(vec2 p) { return vec2(N21(p), N21(p + floor(seed2))); }

float L(vec2 p, vec2 a, vec2 b) {
	vec2 pa = p-a, ba = b-a;
	float t = clamp(dot(pa, ba)/dot(ba, ba), 0.0, 1.0);
	float d = length(pa - ba * t);
	float m = S(0.02, 0.0, d);
	d = length(a-b);
	float f = S(1.0, 0.8, d);
	m *= f;
	m += m*S(0.05, 0.06, abs(d - 0.5)) * 2.0;
	return m;
}

vec2 GetPos(vec2 p, vec2 o) {
	p += o;
	vec2 n = N22(p)*Atime;
	p = sin(n) * line;
	return o+p;
}

float G(vec2 uv) {
	vec2 id = floor(uv);
	uv = fract(uv) - 0.5;
	vec2 g = GetPos(id, vec2(0));
	float m = 0.0;
	for(float y=-1.0; y<=1.0; y++) {
		for(float x=-1.0; x<=1.0; x++) {
			vec2 offs = vec2(x, y);
			vec2 p = GetPos(id, offs);
			m+=L(uv, g, p);
			vec2 a = p-uv;
			float f = 0.003/dot(a, a);
			f *= pow( sin(N21(id+offs) * 6.2831 + (flash*Atime)) * 0.4 + 0.6, flash);
			m += f;
		}
	}
	m += L(uv, GetPos(id, vec2(-1, 0)), GetPos(id, vec2(0, -1)));
	m += L(uv, GetPos(id, vec2(0, -1)), GetPos(id, vec2(1, 0)));
	m += L(uv, GetPos(id, vec2(1, 0)), GetPos(id, vec2(0, 1)));
	m += L(uv, GetPos(id, vec2(0, 1)), GetPos(id, vec2(-1, 0)));
	return m;
}




void main()
{
//	first pass "HoldTime'
	if (PASSINDEX == 0)	{
		vec4 srcPixel = IMG_PIXEL(TimeHold,vec2(0.5));
		srcPixel.x = srcPixel.x + rate;
		gl_FragColor = srcPixel;
	}
		else	{
//  the main pass

 	vec2 uv = (2.25) * ( gl_FragCoord.xy - 0.5 * RENDERSIZE.xy) / RENDERSIZE.y;

 	// a bit of bAjA camera movement :-)
	uv += vec2 (sin(Atime * 0.05)*0.5 , sin(Atime * 0.043)*0.5);

	float m = 0.0;
	for(float i=0.0; i<1.0; i+=0.25) {
		float z = fract(i+Atime/20.0);
		float s = mix(floor(GridCount), 0.5, z);
		float f = S(0.0, 0.4, z) * S(1.0, 0.8, z);
		m += G(uv * s + (N11(i)*100.0) * i) * f;
	}
	vec3 col = m * tint.rgb;
	gl_FragColor = vec4( col, 1.0 );
	}
}
